#include <stdio.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define led1_port PORTA
#define led1_direction DDRA
#define led1 (1<<PA7)

#define button_port PORTA
#define button_direction DDRA
#define button (1<<PA3)
#define button_pins PINA

#define pin_test(pins,pin) (pins & pin) // test for port pin
#define set(port,pin) (port |= pin) // set port pin
#define output(directions,pin) (directions |= pin) // set port direction for output
#define clear(port,pin) (port &= (~pin)) // clear port pin
#define pwm_delay() _delay_ms(100) // pwm delay



void initIO(void) {
    set(led1_port, led1);
    output(led1_direction, led1);
    clear(led1_port,led1);
}

void blinkLed(void){
    set(led1_port,led1);
    pwm_delay();
    clear(led1_port,led1);
    pwm_delay();
    
}

int main(void) {
	initIO();
    while (1) {
         if(0 == pin_test(button_pins, button)){
             blinkLed();
         } else {
           clear(led1_port,led1);
         }
        
    }	return 0; // never reached
}









    
